/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSColorPicking;

import dstep.appkit.NSButtonCell;
import dstep.appkit.NSColor;
import dstep.appkit.NSColorList;
import dstep.appkit.NSColorPanel;
import dstep.appkit.NSImage;
import dstep.appkit.NSView;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

interface INSColorPickingCustom : INSColorPickingDefault
{
	bool supportsMode (int mode);
	int currentMode ();
	NSView provideNewView (bool initialRequest);
	void setColor (NSColor newColor);
}

interface INSColorPickingDefault
{
	Object initWithPickerMask (NSUInteger mask, NSColorPanel owningColorPanel);
	NSImage provideNewButtonImage ();
	void insertNewButtonImage (NSImage newButtonImage, NSButtonCell buttonCell);
	void viewSizeChanged (Object sender);
	void alphaControlAddedOrRemoved (Object sender);
	void attachColorList (NSColorList colorList);
	void detachColorList (NSColorList colorList);
	void setMode (int mode);
	NSString buttonToolTip ();
	NSSize minContentSize ();
}

