/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSPredicateEditorRowTemplate;

import dstep.foundation.NSArray;
import dstep.coredata.NSAttributeDescription;
import dstep.coredata.NSEntityDescription;
import dstep.foundation.NSCoder;
import dstep.foundation.NSComparisonPredicate;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.foundation.NSPredicate;
import dstep.foundation.NSZone;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPredicateEditorRowTemplate : NSObject, INSCoding, INSCopying
{
	mixin (ObjcWrap);
	
	this (NSCoder aDecoder)
	{
		super(typeof(this).alloc.initWithCoder(aDecoder).objcObject);
	}
	
	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}
	
	typeof(this) initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(typeof(this), "initWithCoder:", NSCoder)(aDecoder);
	}
	
	typeof(this) copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(typeof(this), "copyWithZone:", NSZone*)(zone);
	}

	double matchForPredicate (NSPredicate predicate)
	{
		return invokeObjcSelf!(double, "matchForPredicate:", NSPredicate)(predicate);
	}

	NSArray templateViews ()
	{
		return invokeObjcSelf!(NSArray, "templateViews");
	}

	void setPredicate (NSPredicate predicate)
	{
		return invokeObjcSelf!(void, "setPredicate:", NSPredicate)(predicate);
	}

	NSPredicate predicateWithSubpredicates (NSArray subpredicates)
	{
		return invokeObjcSelf!(NSPredicate, "predicateWithSubpredicates:", NSArray)(subpredicates);
	}

	NSArray displayableSubpredicatesOfPredicate (NSPredicate predicate)
	{
		return invokeObjcSelf!(NSArray, "displayableSubpredicatesOfPredicate:", NSPredicate)(predicate);
	}

	NSPredicateEditorRowTemplate initWithLeftExpressions (NSArray leftExpressions, NSArray rightExpressions, uint modifier, NSArray operators, NSUInteger options)
	{
		id result = invokeObjcSelf!(id, "initWithLeftExpressions:rightExpressions:modifier:operators:options:", NSArray, NSArray, uint, NSArray, NSUInteger)(leftExpressions, rightExpressions, modifier, operators, options);
		return result is this.objcObject ? this : (result !is null ? new NSPredicateEditorRowTemplate(result) : null);
	}

	this (NSArray leftExpressions, NSArray rightExpressions, uint modifier, NSArray operators, NSUInteger options)
	{
		super(NSPredicateEditorRowTemplate.alloc.initWithLeftExpressions(leftExpressions, rightExpressions, modifier, operators, options).objcObject);
	}

	NSPredicateEditorRowTemplate initWithLeftExpressions (NSArray leftExpressions, uint attributeType, uint modifier, NSArray operators, NSUInteger options)
	{
		id result = invokeObjcSelf!(id, "initWithLeftExpressions:rightExpressionAttributeType:modifier:operators:options:", NSArray, uint, uint, NSArray, NSUInteger)(leftExpressions, attributeType, modifier, operators, options);
		return result is this.objcObject ? this : (result !is null ? new NSPredicateEditorRowTemplate(result) : null);
	}

	this (NSArray leftExpressions, uint attributeType, uint modifier, NSArray operators, NSUInteger options)
	{
		super(NSPredicateEditorRowTemplate.alloc.initWithLeftExpressions(leftExpressions, attributeType, modifier, operators, options).objcObject);
	}

	NSPredicateEditorRowTemplate initWithCompoundTypes (NSArray compoundTypes)
	{
		id result = invokeObjcSelf!(id, "initWithCompoundTypes:", NSArray)(compoundTypes);
		return result is this.objcObject ? this : (result !is null ? new NSPredicateEditorRowTemplate(result) : null);
	}

	this (NSArray compoundTypes)
	{
		super(NSPredicateEditorRowTemplate.alloc.initWithCompoundTypes(compoundTypes).objcObject);
	}

	NSArray leftExpressions ()
	{
		return invokeObjcSelf!(NSArray, "leftExpressions");
	}

	NSArray rightExpressions ()
	{
		return invokeObjcSelf!(NSArray, "rightExpressions");
	}

	uint rightExpressionAttributeType ()
	{
		return invokeObjcSelf!(uint, "rightExpressionAttributeType");
	}

	uint modifier ()
	{
		return invokeObjcSelf!(uint, "modifier");
	}

	NSArray operators ()
	{
		return invokeObjcSelf!(NSArray, "operators");
	}

	NSUInteger options ()
	{
		return invokeObjcSelf!(NSUInteger, "options");
	}

	NSArray compoundTypes ()
	{
		return invokeObjcSelf!(NSArray, "compoundTypes");
	}

	static NSArray templatesWithAttributeKeyPaths (NSArray keyPaths, NSEntityDescription entityDescription)
	{
		return invokeObjcSelfClass!(NSArray, "templatesWithAttributeKeyPaths:inEntityDescription:", NSArray, NSEntityDescription)(keyPaths, entityDescription);
	}

}

