/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSStepperCell;

import dstep.appkit.NSActionCell;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSStepperCell : NSActionCell
{
	mixin (ObjcWrap);

	double minValue ()
	{
		return invokeObjcSelf!(double, "minValue");
	}

	void setMinValue (double minValue)
	{
		return invokeObjcSelf!(void, "setMinValue:", double)(minValue);
	}

	double maxValue ()
	{
		return invokeObjcSelf!(double, "maxValue");
	}

	void setMaxValue (double maxValue)
	{
		return invokeObjcSelf!(void, "setMaxValue:", double)(maxValue);
	}

	double increment ()
	{
		return invokeObjcSelf!(double, "increment");
	}

	void setIncrement (double increment)
	{
		return invokeObjcSelf!(void, "setIncrement:", double)(increment);
	}

	bool valueWraps ()
	{
		return invokeObjcSelf!(bool, "valueWraps");
	}

	void setValueWraps (bool valueWraps)
	{
		return invokeObjcSelf!(void, "setValueWraps:", bool)(valueWraps);
	}

	bool autorepeat ()
	{
		return invokeObjcSelf!(bool, "autorepeat");
	}

	void setAutorepeat (bool autorepeat)
	{
		return invokeObjcSelf!(void, "setAutorepeat:", bool)(autorepeat);
	}
}

